#!/usr/bin/env python
from datetime import datetime
from importlib import import_module
import os, sys
from flask import Flask, render_template, Response, request,jsonify 
import io
import time
import picamera
from base_camera import BaseCamera
import numpy as np
from PIL import ImageFont, ImageDraw, Image
import cv2
from picamera.array import PiRGBArray
rot=0
z=85
rbc="checked='checked'"
rbc6=""
dpp="DP:ON"
prr="Preview:ON"
mdd="Mode:M"
option="auto"
sh1="off"
iso=0
con=0
bri=50
sat=0
sharp=0
wb8=15 # баланс белого красный
wb9=15 # синий
sl1=0 # Значение для slider1
sl5=0
sl6=0
sl7=0
sl10=0
sl11=0
sl13=50
wh1="3280x2464"
fcam0=250 # фокусное расстояние в пикселях для матрицы 640х480 пикселей
#z1=100
#xt=0
flag=1
flag1=1 # 0 выйти из цикла трансляции видео
fr=12 # частота кадров
camera=picamera.PiCamera()
camera.exposure_mode = "auto"
camera.framerate = fr
ev=int(sl1)-25
camera.exposure_compensation =ev
def infof():    
    gray = cv2.cvtColor(image0, cv2.COLOR_BGR2GRAY)
    fm = cv2.Laplacian(gray, cv2.CV_64F).var()  
    text= str(int(fm))
    return text
def camz(z):
    global fcam, K, D, Knew, z1 
    z1=100
    cx=320
    cy=240
    fcam=100*fcam0/z1
    fsc=z/100
    K = np.array([[  fcam,     0.  ,  cx],
                  [    0.  ,   fcam,   cy],
                  [    0.  ,     0.  ,     1.  ]])

    D = np.array([0., 0., 0., 0.])

    Knew = K.copy()
    Knew[(0,1), (0,1)] = fsc * Knew[(0,1), (0,1)]
class Camera(BaseCamera):
    camz(z)
    #camera.resolution=(640,480)
    @staticmethod
    def frames():
        global image0
        if flag1 == 1:
            if rot == 0 or rot == 180:
                w, h = 640, 480
            else :
                w, h = 480, 640
            camera.resolution=(w, h)
            camera.rotation = rot
            # let camera warm up
            time.sleep(1)
            rawCapture = PiRGBArray(camera, size=(w, h))

            for frame in camera.capture_continuous(rawCapture, format="bgr", use_video_port=True):
                
                image0 = frame.array
                if flag == 2:
                    image0 = cv2.fisheye.undistortImage(image0, K, D=D, Knew=Knew)
                image = cv2.cvtColor(image0, cv2.COLOR_BGR2RGB)
                pil_im = Image.fromarray(image)
                stream= io.BytesIO()
                pil_im.save(stream, format= 'JPEG')

                # return current frame
                stream.seek(0)
                yield stream.read()

                # reset stream for next frame
                rawCapture.truncate(0)
                if flag1 == 0:
                    break

app = Flask(__name__)

@app.route('/')
def index():
    global spa
    #"""Video streaming home page."""
    var=int(camera.exposure_speed)
    spa=str(int(1000000/var))
    return render_template('index.html',val15=z, opt3=wh1, opt=option, opt2=sh1, rb6=rbc6, val14=rot,val12=fcam0, val11=sl11, val10=sl10, val13=sl13, val=sl1, val5=sl5, val6=sl6, val7=sl7, val7a=spa, dp=dpp, pr=prr,md=mdd, val8=wb8, val9=wb9)

@app.route('/process_data/', methods=['POST'])
def doit():
    global flag, flag1, dpp, prr, mdd, spa, sl5, sl6
    index = request.form['index']
    # ... обработать данные ...
    var=int(camera.exposure_speed)
    if index == "1":
        if flag <2:
            flag =2
            dpp="DP:OFF"
        else:
            flag=1
            dpp="DP:ON"
    if index == "2":
        if prr == "Preview:ON":
            flag1=0
            time.sleep(0.2)
            camera.resolution=(1920, 1080)
            camera.start_preview()
            prr="Preview:OFF"
        else:
            camera.stop_preview()
            flag1=1
            prr="Preview:ON"
    if index == "3":
        if mdd == "Mode:M":
            camera.shutter_speed = var
            camera.exposure_mode = "auto"
            time.sleep(0.5)
            camera.exposure_mode = "off"
            mdd="Mode:A"
            sl6=str(int(var/1000))
        else:
            camera.iso = 0
            camera.shutter_speed = 0
            camera.exposure_mode = "auto"
            mdd="Mode:M"
            sl5="0"
            sl6="0"
    if index == "4":
        if wh1 =="3280x2464":
            w, h =3280, 2464
        elif wh1 =="1920x1080":
            w, h =1920, 1080
        elif wh1 =="1640x1232":
            w, h =1640, 1232
        elif wh1 =="2592x1944":
            w, h =2592, 1944
        elif wh1 =="1296x972":
            w, h =1296, 972
        else:
            w,h=640,480
        flag1=0
        time.sleep(0.2)
        camera.resolution=(w, h)
        camera.capture("/home/pi/" + datetime.now().strftime("%d-%b-%Y.(%H_%M_%S_%f)") + ".jpg")
        #camera.resolution=(640,480)
        flag1=1
    spa=str(int(1000000/var))
    return render_template('index.html',val15=z, opt3=wh1, opt=option, opt2=sh1, rb6=rbc6, val14=rot,val12=fcam0, val11=sl11, val10=sl10, val13=sl13, val=sl1, val5=sl5, val6=sl6, val7=sl7, val7a=spa, dp=dpp, pr=prr,md=mdd, val8=wb8, val9=wb9)

@app.route('/process_data2/', methods=['POST'])
def slid():
    global sl1, sl5, sl6, sl7, sl10, sl11, fcam0, sl13, spa,z
    sl1 = request.form['slider1']
    ev=int(sl1)
    camera.exposure_compensation =ev
    sl5 = request.form['slider5']
    iso=int(sl5)*100
    camera.iso = iso
    sl6 = request.form['slider6']
    sp=int(sl6)*1000
    camera.shutter_speed =sp
    sl7 = request.form['slider7']
    con=int(sl7)
    camera.contrast = con
    sl13 = request.form['slider13']
    bri=int(sl13)
    camera.brightness = bri
    sl10 = request.form['slider10']
    sat=int(sl10)
    camera.saturation = sat
    sl11 = request.form['slider11']
    sharp=int(sl11)
    camera.sharpness = sharp
    infsh=infof()
    print(infsh)
    sl12 = request.form['slider12']
    fcam0=int(sl12)
    sl15 = request.form['slider15']
    z=int(sl15)
    camz(z)
    time.sleep(0.1)
    var=int(camera.exposure_speed)
    spa=str(int(1000000/var))
    return render_template('index.html',val15=z, val11a=infsh, opt3=wh1, opt=option, opt2=sh1, rb6=rbc6, val14=rot,val12=fcam0, val11=sl11, val10=sl10, val13=sl13, val=sl1, val5=sl5, val6=sl6, val7=sl7, val7a=spa, dp=dpp, pr=prr,md=mdd, val8=wb8, val9=wb9)
@app.route('/process_data14/', methods=['POST'])
def rotcam():
    global rot, flag1
    sl14 = request.form['slider14']
    rot=int(sl14)
    flag1=0
    time.sleep(0.2)
    flag1=1
    return render_template('index.html',val15=z, opt3=wh1, opt=option, opt2=sh1, rb6=rbc6, val14=rot,val12=fcam0, val11=sl11, val10=sl10, val13=sl13, val=sl1, val5=sl5, val6=sl6, val7=sl7, val7a=spa, dp=dpp, pr=prr,md=mdd, val8=wb8, val9=wb9)
def gen(camera):
    """Video streaming generator function."""
    while True:
        frame = camera.get_frame()
        yield (b'--frame\r\n'
               b'Content-Type: image/jpeg\r\n\r\n' + frame + b'\r\n')
@app.route('/process_data8/', methods=['POST'])
def rad():
    global spa, option,wb8, wb9, rbc6
    option = request.form['options']
    wb8 = request.form['slider8']
    wb9 = request.form['slider9']
    # ... обработать данные ...
    camera.awb_mode = option
    if option =="off":
        r=int(wb8)/10
        b=int(wb9)/10
        camera.awb_gains =(r,b)
        rbc6=rbc
    else:
        rbc6=""
    
    print(option,wb8,wb9)
    
    
    return render_template('index.html',opt3=wh1, opt=option, opt2=sh1, rb6=rbc6, val14=rot,val12=fcam0, val11=sl11, val10=sl10, val13=sl13, val=sl1, val5=sl5, val6=sl6, val7=sl7, val7a=spa, dp=dpp, pr=prr,md=mdd, val8=wb8, val9=wb9)
@app.route('/process_data3/', methods=['POST'])
def sh():
    global sh1
    sh1 = request.form['opt']
    # ... обработать данные ...
    camera.drc_strength = sh1
    print(sh1)
    
    return render_template('index.html',opt3=wh1, opt=option, opt2=sh1, rb6=rbc6, val14=rot,val12=fcam0, val11=sl11, val10=sl10, val13=sl13, val=sl1, val5=sl5, val6=sl6, val7=sl7, val7a=spa, dp=dpp, pr=prr,md=mdd, val8=wb8, val9=wb9)
@app.route('/process_data5/', methods=['POST'])
def wh():
    global wh1
    wh1 = request.form['opti']

    print(wh1)
    
    return render_template('index.html',opt3=wh1, opt=option, opt2=sh1, rb6=rbc6, val14=rot,val12=fcam0, val11=sl11, val10=sl10, val13=sl13, val=sl1, val5=sl5, val6=sl6, val7=sl7, val7a=spa, dp=dpp, pr=prr,md=mdd, val8=wb8, val9=wb9)
@app.route('/video_feed')
def video_feed():
    """Video streaming route. Put this in the src attribute of an img tag."""
    return Response(gen(Camera()),
                    mimetype='multipart/x-mixed-replace; boundary=frame')


if __name__ == '__main__':
    app.run(host='0.0.0.0', threaded=True)
